{if $method == "get"}
    
    <li class="feedItem">
        <div class="dataContainer" id="{$answer.ID}-{$post.PostType}-{$post.PostID}-{$answer.UserID}">
            
            <!-- Vote Box -->
            <div class="dataSideWrapper small">
                <div class="voteBox doVoteUp {if $answer.voted == 'U'}active{/if}"><i class="up"></i></div>
                <div class="voteBox doVoteDown {if $answer.voted == 'D'}active{/if}"><i class="down"></i></div>
            </div>
            <!-- Vote Box -->
            
            <!-- Votes -->
            <div class="dataSideWrapper ml5">
                <div class="questionBox">
                    <div class="questionBoxCounts">{$answer.Votes}</div>
                    <div>votes</div>
                </div>
            </div>
            <!-- Votes -->
            
            <!-- Answer Data -->
            <div class="dataContentWrapper small ml10">
                
                <!-- Buttons & UserName -->
                <div class="dataContent mb5">
                    
                    {if $userExist}
                        <!-- Buttons -->
                        <div class="dataButtons hidden">
                            <div class="right">
                                {if $answer.UserID == $userArray.UserID}
                                    <div class="button-close doRemoveAnswer"></div>
                                {else}
                                    <div class="{if $userArray.UserGroup < 3}button-edit{else}button-close{/if} closeNode"></div>
                                    <div class="subMenu closeMenu">
                                        <ul>
                                            <li><span class="menuItem doSpamAnswer">Mark as spam</span></li>
                                            <li><span class="menuItem doReportAnswer">Report as Abuse</span></li>
                                            {if $userArray.UserGroup < 3}
                                                <li class="moderator"></li>
                                                <li><span class="menuItem doRemoveAnswer">Delete this answer</span></li>
                                            {/if}
                                        </ul>
                                    </div>
                                {/if}
                            </div>
                        </div>
                        <!-- Buttons -->
                    {/if}
                    
                    <!-- User Name -->
                    <span class="relative showHoverCard" id="{$answer.UserID}">
                        <strong><a href="{$SITE_URL}/{$answer.UserName}">{$answer.UserFirstName} {$answer.UserLastName}</a></strong>
                        <!-- Hover Card -->
                        <div class="hoverCardWrapper hidden"></div>
                        <!-- Hover Card -->
                    </span>
                    <!-- User Name -->
                    
                </div>
                <!-- Buttons & UserName -->
                
                <!-- Data -->
                <div class="dataContent mb10">{$answer.Text}</div>
                <!-- Data -->
                
                <!-- Statistics -->
                <div class="dataContent mb5 gray">
                    {if $userExist}<span class="uiButtonText addNote">Note</span> · {/if}<span class="timeago" data-time="{$answer.Time}" title="{$answer.Time|date_format:"%A, %B %e, %Y at %I:%M %p"}"></span>
                </div>
                <!-- Statistics -->
                
                <!-- Notes -->
                {if $answer.notes > 0}
                    <ul id="streamNotes">
                        <!-- Previous Notes -->
                        {if $answer.prevNotes > 0}
                            <!-- View More -->
                            <div class="viewMore mt10 viewMoreNotes" id="{$answer.prevNotes}">
                                <div class="right hidden"><img src="{$spinner.small}" /></div>
                                View previous notes
                            </div>
                            <!-- View More -->
                        {/if}
                        <!-- Previous Notes -->
                        
                        {foreach $answer.notes as $note}
                            {include file='ajax.answers.note.tpl' method='get'}
                        {/foreach}
                    </ul>
                {else}
                    <ul id="streamNotes"></ul>
                {/if}
                <!-- Notes -->
                
                <!-- Add a Note -->
                <form class="postNote hidden">
                    <div class="commentContainer postCommentWrapper">
                        <div class="dataSideWrapper small"></div>
                        <div class="dataSideWrapper ml5">
                            <img src="{$SITE_URL}/{$userArray.UserAvatarPathMedium}" />
                        </div>
                        <div class="dataContentWrapper vsmall ml10">
                            <div class="commentContent small mb5">
                                <textarea class="uiInput addReply expand">Write an note...</textarea>
                            </div>
                            <div class="commentContent small tright mb10">
                                <input class="uiButton" type="submit" value="Note" />
                                <div class="hidden"><img src="{$spinner.small}" /></div>
                            </div>
                        </div>
                    </div>
                </form>
                <!-- Add a Note -->
                
            </div>
            <!-- Answer Data -->
            
            <!-- Avatar -->
            <div class="dataSideWrapper medium ml10">
                <a href="{$SITE_URL}/{$answer.UserName}"><img src="{$SITE_URL}/{$answer.UserAvatarPath}" /></a>
            </div>
            <!-- Avatar -->
            
        </div>
    </li>
    
{elseif $method == "post"}
    
    <li class="feedItem">
        <div class="dataContainer" id="{$answer.ID}-{$post.PostType}-{$post.PostID}-{$userArray.UserID}">
            
            <!-- Vote Box -->
            <div class="dataSideWrapper small">
                <div class="voteBox doVoteUp"><i class="up"></i></div>
                <div class="voteBox doVoteUp"><i class="down"></i></div>
            </div>
            <!-- Vote Box -->
            
            <!-- Votes -->
            <div class="dataSideWrapper ml5">
                <div class="questionBox">
                    <div class="questionBoxCounts">0</div>
                    <div>votes</div>
                </div>
            </div>
            <!-- Votes -->
            
            <!-- Answer Data -->
            <div class="dataContentWrapper small ml10">
                
                <!-- Buttons & UserName -->
                <div class="dataContent mb5">
                    
                    <!-- Buttons -->
                    <div class="dataButtons hidden">
                        <div class="right">
                            <div class="button-close removeAnswer"></div>
                        </div>
                    </div>
                    <!-- Buttons -->
                    
                    <!-- User Name -->
                    <span class="relative showHoverCard" id="{$userArray.UserID}">
                        <strong><a href="{$SITE_URL}/{$userArray.UserName}">{$userArray.UserFirstName} {$userArray.UserLastName}</a></strong>
                        <!-- Hover Card -->
                        <div class="hoverCardWrapper hidden"></div>
                        <!-- Hover Card -->
                    </span>
                    <!-- User Name -->
                    
                </div>
                <!-- Buttons & UserName -->
                
                <!-- Data -->
                <div class="dataContent mb10">{$answer.Text}</div>
                <!-- Data -->
                
                <!-- Statistics -->
                <div class="dataContent mb5 gray">
                    <span class="uiButtonText addNote">Note</span> · <span class="timeago" data-time="{$answer.Time}" title="{$answer.Time|date_format:"%A, %B %e, %Y at %I:%M %p"}"></span>
                </div>
                <!-- Statistics -->
                
                <!-- Notes -->
                <ul id="streamNotes"></ul>
                <!-- Notes -->
                
                <!-- Add a Note -->
                <form class="postNote hidden">
                    <div class="commentContainer postCommentWrapper">
                        <div class="dataSideWrapper small"></div>
                        <div class="dataSideWrapper ml5">
                            <img src="{$SITE_URL}/{$userArray.UserAvatarPathSmall}" />
                        </div>
                        <div class="dataContentWrapper vsmall ml10">
                            <div class="commentContent small mb5">
                                <textarea class="uiInput addReply expand">Write an note...</textarea>
                            </div>
                            <div class="commentContent small tright mb10">
                                <input class="uiButton" type="submit" value="Note" />
                                <div class="hidden"><img src="{$spinner.small}" /></div>
                            </div>
                        </div>
                    </div>
                </form>
                <!-- Add a Note -->
                
            </div>
            <!-- Answer Data -->
            
            <!-- Avatar -->
            <div class="dataSideWrapper medium ml10">
                <a href="{$SITE_URL}/{$userArray.UserName}"><img src="{$SITE_URL}/{$userArray.UserAvatarPathSmall}" /></a>
            </div>
            <!-- Avatar -->
            
        </div>
    </li>
    
{/if}